// ML1 - multilot clone based on sma filter
// author - fryk@tlen.pl, 2006

#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+
extern bool Usefilewrite = true;
extern int BarsBack = 8;
extern double Lots = 0.1;
extern double StopLoss = 40.0;
extern double TakeProfit = 13.00;
extern double LotIncreaseFactor = 0.21;//Added by Aaragorn 9-11-06 to increase lots based on account free margin
//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double MaxTrades = 5;
extern double Pips = 3;
extern double AccountProtection = 1;
extern double mm = 0;
extern double risk = 0.15;
extern double AccountisNormal = 0;
extern int mP = 28;
extern int mI = 1;
extern double mL = 1.85;
extern int MagicNumber = 45453434;
//+------------------------------------------------------------------+
//| Global variables                                                 |
//+------------------------------------------------------------------+
double OpenOrders = 0;
int cnt = 0;
double slippage = 5;
double sl = 0;
double tp = 0;
double BuyPrice = 0;
double SellPrice = 0;
double lotsi = 0;
double mylotsi = 0;
double mode = 0;
double MyOrderType=0;
bool ContinueOpening = True;
double LastPrice = 0;
double PreviousOpenOrders = 0;
double Profit = 0;
double LastTicket = 0;
double LastType = 0;
double LastClosePrice = 0;
double LastLots = 0;
double Spread = 0;
//double ma1=0, ma2=0;
//---- filewrite variables
int handle;
double ma1=0,ma2=0;
double hc=0,lc=0,ho=0,lo=0,hoc=0,loc=0;
int start()
{
   //highest open or close 'BarsBack' bars
         hc = High[Highest(NULL,0,MODE_CLOSE,BarsBack,0)];
         lc = Low[Lowest(NULL,0,MODE_CLOSE,BarsBack,0)];
         ho = High[Highest(NULL,0,MODE_OPEN,BarsBack,0)];
         lo = Low[Lowest(NULL,0,MODE_OPEN,BarsBack,0)];
         //---we calculate the highest/lowest open/close
         if(hc>ho)
            {
            hoc = hc;
            }     
            else
            {
            hoc = ho;
            }
         if(lc<lo)
            {
            loc = lc;
            }     
            else
            {
            loc = lo;
            }


if( mm != 0 ) lotsi = NormalizeDouble( (AccountFreeMargin() / 50.0) * (risk/100.0), 2); else lotsi = Lots;
if ( lotsi < 0.01 ) lotsi = 0.01;
if( lotsi > 100 ) lotsi = 100;

OpenOrders = 0;
for( cnt = 0; cnt < OrdersTotal(); cnt++ ) {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if( OrderSymbol() ==  Symbol() ) OpenOrders++;
}
      
if( PreviousOpenOrders > OpenOrders ) {
   for( cnt = OrdersTotal()-1; cnt >= 0; cnt-- ) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      mode = OrderType();
      if( OrderSymbol() == Symbol() ) 
      {
         if( mode ==  OP_BUY )  
            {
            OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Blue);
            if (Usefilewrite)
            {  
               if(OrderOpenPrice() + Spread < OrderClosePrice())
               {   
                  datetime borderOpen=OrderOpenTime();
                  handle = FileOpen("Multi4.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Winning Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",borderOpen);
                    FileWrite(handle,"AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                    FileWrite(handle,"  ");
                    
                    FileFlush(handle);
	                 FileClose(handle);
	                 Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
	                 }   
                    else
                    {
                    int err;
                    err=GetLastError();
                    Print("error(",err,"): ",ErrorDescription(err));
                    //return(0);                     
                    } 
                 }//if win
                 Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);     

               if(OrderOpenPrice() + Spread >= OrderClosePrice())
               {
                  datetime blorderOpen=OrderOpenTime();
                  handle = FileOpen("Multi4.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Losing Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",blorderOpen);
                    FileWrite(handle,"AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                    FileWrite(handle,"  ");
                    FileFlush(handle);
	                 FileClose(handle);
	                 Print("Recorded Losing Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
                   
	                 }   
                    else
                    {
                    int err1;
                    err1=GetLastError();
                    Print("error(",err1,"): ",ErrorDescription(err1));
                    return(0);                     
                    } 
                }//if lose  
            }//if use file write  
            }
         if( mode ==  OP_SELL )
            {
            OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Red);
            if (Usefilewrite)
            {  
              if(OrderOpenPrice() - Spread > OrderClosePrice()) 
               {
                  datetime sorderOpen=OrderOpenTime();
                  handle = FileOpen("Multi4.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Winning Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",sorderOpen);
                    FileWrite(handle,"AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                    FileWrite(handle,"  ");
                    FileFlush(handle);
	                 FileClose(handle);
                    Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);
                    }   
                    else
                    {
                    int err3;
                    err3=GetLastError();
                    Print("error(",err3,"): ",ErrorDescription(err3));
                    //return(0);                     
                    }  
               }//if win 
               //Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask); 
              
               if(OrderOpenPrice() - Spread <= OrderClosePrice())
                  {  
                  datetime slorderOpen=OrderOpenTime();
                  handle = FileOpen("Multi4.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Losing Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",slorderOpen);
                    FileWrite(handle,"AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                    FileWrite(handle,"  ");
                    FileFlush(handle);
	                 FileClose(handle);
                    Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);
                    }   
                    else
                    {
                    int err4;
                    err4=GetLastError();
                    Print("error(",err4,"): ",ErrorDescription(err4));
                    return(0);                     
                    }  
                  }//if lose 
                  //Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);   
            }//if use file write
            }
         Sleep(20);
      }
   }
   OpenOrders=0;
}

PreviousOpenOrders = OpenOrders;
if( OpenOrders >= MaxTrades ) ContinueOpening = False ; else ContinueOpening = True;

ma1=iMA(NULL,PERIOD_M15,mP,0,0,5,0+mI);
ma2=iMA(NULL,PERIOD_M15,mP,0,0,5,1+mI);
bool NewOrder=false;

if ( MathAbs(ma1-ma2)/Point > mL )
{
   NewOrder = true;
}

if( OpenOrders < 1 ) MyOrderType=0;
if( OpenOrders < 1 && NewOrder == true && ma1 < ma2 ) {
   LastPrice = 0;
   MyOrderType=1;
}
if( OpenOrders < 1 && NewOrder == true && ma1 > ma2 ) {
   LastPrice = 0;
   MyOrderType=2;
}

LastTicket = 0;
LastType = 0;
LastClosePrice = 0;
LastLots = 0;

for( cnt = 0; cnt < OrdersTotal(); cnt++ ) {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if( OrderSymbol() == Symbol() ) {
         LastPrice = OrderOpenPrice();
         if(OrderType()==OP_BUY)  MyOrderType=2;
         if(OrderType()==OP_SELL)  MyOrderType=1;

      LastTicket = OrderTicket();
      if( OrderType() ==  OP_BUY ) LastType = 0;
      if( OrderType() ==  OP_SELL ) LastType = 1;
      LastClosePrice = OrderClosePrice();
      LastLots = OrderLots();
   }
}

if( MyOrderType == 1 && ContinueOpening ) {
   if( Bid - LastPrice >= Pips * Point || OpenOrders < 1 ) {
      SellPrice = Bid;
      LastPrice = 0;
      if( TakeProfit ==  0 ) tp = 0 ; else tp = SellPrice - TakeProfit * Point;
      if( StopLoss ==  0 ) sl = 0 ; else sl = SellPrice + StopLoss * Point;
      if( OpenOrders != 0 ) {
         mylotsi = lotsi;
         for(cnt =0;cnt <OpenOrders;cnt ++) {
            if( MaxTrades > 12 ) mylotsi = NormalizeDouble(mylotsi * 1.5,2) ; else mylotsi = NormalizeDouble(mylotsi * 2,2);
         }
      }
      else {
         mylotsi = lotsi;
      }
///SHORTS //Added by Aaragorn 9-18-06 to increase lots based on account free margin     
if( OpenOrders == 0 )
{
mylotsi = 0.01;
}
if( OpenOrders == 1 )
{
mylotsi = 0.02;
}
if(OpenOrders == 2)
{
LotIncreaseFactor = 1;
mylotsi = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000/0.1),1);
  /*if()
      {
   
      }*/
}
if(OpenOrders == 3)
{
//LotIncreaseFactor = 1.6;
mylotsi = 0.04;
//mylotsi = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000/0.1),1);
}
if(OpenOrders == 4)
{
//LotIncreaseFactor = 1.6;
mylotsi = 0.03;
//mylotsi = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000/0.1),1);
}
///
      if( mylotsi > 100 ) mylotsi = 100;
      if( mylotsi < 0.01 ) mylotsi = 0.01;
      OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage,sl,tp,"",MagicNumber,0,Red);
      sellfilewrite();
      return(0);
   }
}

if( MyOrderType == 2 && ContinueOpening ) {
   if( LastPrice - Ask >= Pips * Point || OpenOrders < 1 ) {
      BuyPrice = Ask;
      LastPrice = 0;
      if( TakeProfit ==  0 ) tp = 0 ; else tp = BuyPrice + TakeProfit * Point;
      if( StopLoss ==  0 ) sl = 0 ; else sl = BuyPrice - StopLoss * Point;
      if( OpenOrders != 0 ) {
         mylotsi = lotsi;
         for(cnt =0;cnt <OpenOrders;cnt ++) {
            if( MaxTrades > 12 ) mylotsi = NormalizeDouble(mylotsi * 1.5,2) ; else mylotsi = NormalizeDouble(mylotsi * 2,2);
         }
      }
      else {
         mylotsi = lotsi;
      }
////LONGS //Added by Aaragorn 9-18-06 to increase lots based on account free margin     
if( OpenOrders == 0 )
{
mylotsi = 0.01;
}
if( OpenOrders == 1 )
{
mylotsi = 0.02;
}
if(OpenOrders == 2)
{
//LotIncreaseFactor = 1;
//mylotsi = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000/0.1),1);
    if( ((hoc - Ask > 0.0007) && (hoc - Ask < 0.0010)) || ((hoc - Ask > 0.0012) && (hoc - Ask < 0.0014)) )
      {
      mylotsi = 2;
      }
   // if( (hoc - Ask != 8) || (hoc - Ask != 9) || (hoc - Ask != 13) )
    //  {
     // mylotsi = 0;
    //  }
}
if(OpenOrders == 3)
{
//LotIncreaseFactor = 1.6;
mylotsi = 0.04;
//mylotsi = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000/0.1),1);
}
if(OpenOrders == 4)
{
//LotIncreaseFactor = 1.6;
mylotsi = 0.03;
//mylotsi = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000/0.1),1);

}
////      
      if( mylotsi > 100 ) mylotsi = 100;
      if( mylotsi < 0.01 ) mylotsi = 0.01;
      OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage,sl,tp,"",MagicNumber,0,Blue);
      buyfilewrite();
      return(0);
   }
}

return(0);
}
//////////////////////////filewrite functions by Aaragorn/////////////////////////////////
void buyfilewrite()
{
   if(Usefilewrite)
   {
  //    for(int cnt = 0; cnt < OrdersTotal(); cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS);
         if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
         {
         if(OrderType() == OP_BUY)// If order is a long position
            {
            datetime sorderOpen=OrderOpenTime();
            handle = FileOpen("Multi4.txt",FILE_READ|FILE_WRITE);
            if(handle!=-1)
              {
                  FileSeek(handle,0,SEEK_END);
                  
                  FileWrite(handle,"Opened Long #: ",OrderTicket()," Order Open Time: ",sorderOpen);
                  FileWrite(handle,"Lots: ",mylotsi," @Ask: ",Ask," Slippage: ",slippage," Stop Loss: ",sl," Take Profit: ",tp );
                  FileWrite(handle,"OpenOrders: ",OpenOrders," hoc: ",hoc," loc: ",loc," ma1: ",NormalizeDouble(ma1,6)," ma2: ",NormalizeDouble(ma2,6));                                   
                  FileWrite(handle,"AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                  FileWrite(handle,"  ");
                  FileFlush(handle);
                  FileClose(handle);
              }   
              else
               {
               int err;
               err=GetLastError();
               Print("error(",err,"): ",ErrorDescription(err));

               return(0);                     
               }
            }//if type is buy            
         }//if symbol and magic number                  
      }//for count                     
   }//if use file write
}//filewrite   


void sellfilewrite()
{
   if(Usefilewrite)
   {
     // for(int cnt = 0; cnt < OrdersTotal(); cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS);
         if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
         {
         if(OrderType() == OP_SELL)// If order is a long position
            {
            datetime sorderOpen=OrderOpenTime();
            handle = FileOpen("Multi4.txt",FILE_READ|FILE_WRITE);
            if(handle!=-1)
              {
                  FileSeek(handle,0,SEEK_END);
                  
                  FileWrite(handle,"Opened Short #: ",OrderTicket()," Order Open Time: ",sorderOpen);
                  FileWrite(handle,"Lots: ",mylotsi," @Bid: ",Bid," Slippage: ",slippage," Stop Loss: ",sl," Take Profit: ",tp );
                  FileWrite(handle,"OpenOrders: ",OpenOrders," hoc: ",hoc," loc: ",loc," ma1: ",NormalizeDouble(ma1,6)," ma2: ",NormalizeDouble(ma2,6));                                   
                  FileWrite(handle,"AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                  FileWrite(handle,"  ");
                  FileFlush(handle);
                  FileClose(handle);
              }   
              else
               {
               int err;
               err=GetLastError();
               Print("error(",err,"): ",ErrorDescription(err));

               return(0);                     
               }
            }//if type is buy            
         }//if symbol and magic number                  
      }//for count                     
   }//if use file write
}//filewrite   

/*
/////////////record outcomes////////////by Aaragorn///////////
void RecordLongOutcomes()
{
   Spread = Ask - Bid;
   //OrderSelect(OrderTicket(),SELECT_BY_POS,MODE_TRADES);
   if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
      if(OrderType()==OP_BUY)
         {
         if (Usefilewrite)
            {  
               if(OrderOpenPrice() + Spread < OrderClosePrice())
               {   
                  datetime borderOpen=OrderOpenTime();
                  handle = FileOpen("Multi4.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Winning Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",borderOpen);
                    FileWrite(handle,"  ");
                    
                    FileFlush(handle);
	                 FileClose(handle);
	                 Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
	                 }   
                    else
                    {
                    int err;
                    err=GetLastError();
                    Print("error(",err,"): ",ErrorDescription(err));
                    //return(0);                     
                    } 
                 }//if win
                 Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);     

               if(OrderOpenPrice() + Spread >= OrderClosePrice())
               {
                  datetime blorderOpen=OrderOpenTime();
                  handle = FileOpen("Multi4.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Losing Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",blorderOpen);
                    FileWrite(handle,"  ");
                    FileFlush(handle);
	                 FileClose(handle);
	                 Print("Recorded Losing Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
                   
	                 }   
                    else
                    {
                    int err1;
                    err1=GetLastError();
                    Print("error(",err1,"): ",ErrorDescription(err1));
                    return(0);                     
                    } 
                }//if lose  
            }//if use file write  
         }//if buy
      }//if symbol and magic number   
   return (0);
}//record long winner outcomes

void RecordShortOutcomes()
{
   Spread = Ask - Bid;
   //OrderSelect(OrderTicket(),SELECT_BY_POS,MODE_TRADES);
   if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
      if(OrderType()==OP_SELL)
         {
         if (Usefilewrite)
            {  
              if(OrderOpenPrice() - Spread > OrderClosePrice()) 
               {
                  datetime sorderOpen=OrderOpenTime();
                  handle = FileOpen("Multi4.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Winning Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",sorderOpen);
                    FileWrite(handle,"  ");
                    FileFlush(handle);
	                 FileClose(handle);
                    Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
                    }   
                    else
                    {
                    int err3;
                    err3=GetLastError();
                    Print("error(",err3,"): ",ErrorDescription(err3));
                    //return(0);                     
                    }  
               }//if win 
               //Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid); 
              
               if(OrderOpenPrice() - Spread <= OrderClosePrice())
                  {  
                  datetime slorderOpen=OrderOpenTime();
                  handle = FileOpen("Multi4.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Losing Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",slorderOpen);
                    FileWrite(handle,"  ");
                    FileFlush(handle);
	                 FileClose(handle);
                    Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
                    }   
                    else
                    {
                    int err4;
                    err4=GetLastError();
                    Print("error(",err4,"): ",ErrorDescription(err4));
                    return(0);                     
                    }  
                  }//if lose 
                  //Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);   
            }//if use file write
         }//if sell 
      }//if symbol and magic number   
   return (0);
}//record short winner outcomes


*/



/////////////end of record outcomes////////////by Aaragorn///////////   